package NOCpulse::ObjectProxy;
#
# Copyright (c) 2009 Red Hat, Inc.
#
# This software is licensed to you under the GNU General Public License,
# version 2 (GPLv2). There is NO WARRANTY for this software, express or
# implied, including the implied warranties of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. You should have received a copy of GPLv2
# along with this software; if not, see
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt.
#
# Red Hat trademarks are not licensed under GPLv2. No permission is
# granted to use or replicate Red Hat trademarks that are incorporated
# in this software or its documentation.
#
use FreezeThaw qw(freeze thaw);

sub newInitialized
{
	my ($class,$connection) = @_;
	$class = ref($class)||$class;
	my $self = {};
	bless($self,$class);
	$self->{'connection'} = $connection;
	return $self;
}

sub DESTROY
{
	# so we actually do nothing
}

sub AUTOLOAD
{
        my ($self,@params) = @_;
        my ($class,$method) = ($AUTOLOAD =~ /(.*)::(.*)$/);
	my $frozenParams = freeze(@params);
	my $protoString = $method.','.$frozenParams;
	$self->{'connection'}->sendAll($protoString);
	# This must block 'til the remote end returns something.
	my $frozenData = $self->{'connection'}->readAll;
	return thaw($frozenData);
}
1
